<?php
/*
Plugin Name: CW World News
Plugin URI: http://wordpress.org/plugins/feedzilla-news/
Description: A Feedzilla (http://feezilla.com) client.
Author: CadreWorks Pty Ltd
Version: 2.2
Author URI: http://cadreworks.com
*/

function cw_feedzilla_submit() {
  echo "Called cw_feedzilla_submit";
}

add_action('admin_menu', 'cw_feedzilla_plugin_menu');
add_action('wp_enqueue_scripts', 'cw_feedzilla_scripts');

//AJAX actions
add_action('wp_ajax_cw_feedzilla_refresh', 'cw_feedzilla_refresh_callback');
add_action('wp_ajax_nopriv_cw_feedzilla_refresh', 'cw_feedzilla_refresh_callback');
add_action('wp_ajax_cw_feedzilla_refresh_with_names', 'cw_feedzilla_refresh_with_names_callback');
add_action('wp_ajax_nopriv_cw_feedzilla_refresh_with_names', 'cw_feedzilla_refresh_with_names_callback');
add_action('wp_ajax_cw_feedzilla_cultures', 'cw_feedzilla_cultures_callback');
add_action('wp_ajax_nopriv_cw_feedzilla_cultures', 'cw_feedzilla_cultures_callback');
add_action('wp_ajax_cw_feedzilla_categories', 'cw_feedzilla_categories_callback');
add_action('wp_ajax_nopriv_cw_feedzilla_categories', 'cw_feedzilla_categories_callback');
add_action('wp_ajax_cw_feedzilla_subcategories', 'cw_feedzilla_subcategories_callback');
add_action('wp_ajax_nopriv_cw_feedzilla_subcategories', 'cw_feedzilla_subcategories_callback');

//Admin AJAX Action
add_action('wp_ajax_cw_feedzilla_clear_cache', 'cw_feedzilla_clear_cache_callback');

add_shortcode('cw_feedzilla_newsfeed', 'cw_feedzilla_newsfeed_handler');

function cw_feedzilla_plugin_menu() {
	add_options_page( 'CW World News Options', 'CW World News', 'manage_options', 'cw-feedzilla', 'cw_feedzilla_plugin_options' );
}

function cw_feedzilla_plugin_options() {
  if ( !current_user_can( 'manage_options' ) )  {
    wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
  }
  $hidden_field_name = 'cw_feedzilla_submit';
  $api_url_field_name = 'cw_feedzilla_api_url';
  $headline_count_field_name = 'cw_feedzilla_headline_count';
  $title_only_field_name = 'cw_feedzilla_title_only';
  $include_images_field_name = 'cw_feedzilla_include_images';
  $auto_refresh_field_name = 'cw_feedzilla_auto_refresh';
  $addthis_id_field_name = 'cw_feedzilla_addthis_id';
  $addthis_field_name = 'cw_feedzilla_addthis';

  $api_url_opt_name = 'cw_feedzilla_api_url';
  $headline_count_opt_name = 'cw_feedzilla_headline_count';
  $title_only_opt_name = 'cw_feedzilla_title_only';
  $include_images_opt_name = 'cw_feedzilla_include_images';
  $auto_refresh_opt_name = 'cw_feedzilla_auto_refresh';
  $addthis_id_opt_name = 'cw_feedzilla_addthis_id';
  $addthis_opt_name = 'cw_feedzilla_addthis';

    // Read in existing option value from database
  $api_url = get_option( $api_url_opt_name, 'http://api.feedzilla.com/v1' );
  $headline_count = get_option( $headline_count_opt_name, 20 );
  $title_only = get_option( $title_only_opt_name, false );
  $include_images = get_option( $include_images_opt_name, true );
  $auto_refresh = get_option( $auto_refresh_opt_name, true );
  $addthis_id = get_option( $addthis_id_opt_name, 'ra-52d85cbe4587626d' );
  $addthis = get_option( $addthis_opt_name, 'disabled' );

  // See if the user has posted us some information
  // If they did, this hidden field will be set to 'Y'
  if( isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {
      // Read their posted value
      $api_url = $_POST[ $api_url_field_name ];
      $headline_count = $_POST[ $headline_count_field_name ];
      $title_only = isset($_POST[ $title_only_field_name ]);
      $include_images = isset($_POST[ $include_images_field_name ]);
      $auto_refresh = isset($_POST[ $auto_refresh_field_name ]);
      $addthis_id = $_POST[ $addthis_id_field_name ];
      $addthis = $_POST[ $addthis_field_name ];

      // Save the posted value in the database
      update_option( $api_url_opt_name, $api_url );
      update_option( $headline_count_opt_name, $headline_count );
      update_option( $title_only_opt_name, $title_only );
      update_option( $include_images_opt_name, $include_images );
      update_option( $auto_refresh_opt_name, $auto_refresh );
      update_option( $addthis_id_opt_name, $addthis_id );
      update_option( $addthis_opt_name, $addthis );

      // Put an settings updated message on the screen

?>
<div class="updated"><p><strong><?php _e('Settings saved.', 'menu-cw_feedzilla' ); ?></strong></p></div>
<?php

  }

  // Now display the settings editing screen

  echo '<div class="wrap">';

  // header

  echo "<h2>" . __( 'CW World News Plugin Settings', 'cw_feedzilla' ) . "</h2>";

  // settings form
    
  ?>

<form name="form1" method="post" action="" enctype="multipart/form-data">
<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">
<p/>
<table>
  <tr>
    <th colspan="2" align="left">
      Connection Settings
    </th>
  </tr>
  <tr>
    <td>
      <?php _e("API URL:", 'cw_feedzilla' ); ?> 
    </td>
    <td>
      <input type="text" name="<?php echo $api_url_field_name; ?>" value="<?php echo $api_url; ?>" size="20">
    </td>
  </tr>
  <tr>
    <td><p/></td>
  </tr>
  <tr>
    <th colspan="2" align="left">
      Display Settings
    </th>
  </tr>
  <tr>
    <td>
      <?php _e("Headline Count:", 'cw_feedzilla' ); ?> 
    </td>
    <td>
      <input type="text" name="<?php echo $headline_count_field_name; ?>" value="<?php echo $headline_count; ?>" size="10">
    </td>
  </tr>
  <tr>
    <td>
      <?php _e("Titles Only:", 'cw_feedzilla' ); ?> 
    </td>
    <td>
      <input type="checkbox" name="<?php echo $title_only_field_name; ?>" <?php if ($title_only) { ?>checked<?php } ?>/>
    </td>
  </tr>
  <tr>
    <td>
      <?php _e("Include Images:", 'cw_feedzilla' ); ?> 
    </td>
    <td>
      <input type="checkbox" name="<?php echo $include_images_field_name; ?>" <?php if ($include_images) { ?>checked<?php } ?>/>
    </td>
  </tr>
  <tr>
    <td>
      <?php _e("Auto Refresh:", 'cw_feedzilla' ); ?> 
    </td>
    <td>
      <input type="checkbox" name="<?php echo $auto_refresh_field_name; ?>" <?php if ($auto_refresh) { ?>checked<?php } ?>/>
    </td>
  </tr>
  <tr>
    <td><p/></td>
  </tr>
  <tr>
    <th colspan="2" align="left">
      AddThis Settings
    </th>
  </tr>
  <tr>
    <td>
      <?php _e("AddThis Account ID:", 'cw_feedzilla' ); ?> 
    </td>
    <td>
      <input type="text" name="<?php echo $addthis_id_field_name; ?>" value="<?php echo $addthis_id ?>"/><br/>
      Register for your own ID at <a href="addthis.com">addthis.com</a>.
    </td>
  </tr>
  <tr>
    <td>
      <?php _e("Disabled:", 'cw_feedzilla' ); ?> 
    </td>
    <td>
      <input type="radio" name="<?php echo $addthis_field_name; ?>" value="disabled" <?php if ($addthis == "disabled") { ?>checked<?php } ?>/>
    </td>
  </tr>
  <tr>
    <td>
      <img src="<?php echo plugins_url('/img/addthis_default.png', __FILE__) ?>" alt="Default AddThis button"/>
    </td>
    <td>
      <input type="radio" name="<?php echo $addthis_field_name; ?>" value="default" <?php if ($addthis == "default") { ?>checked<?php } ?>/>
    </td>
  </tr>
  <tr>
    <td>
      <img src="<?php echo plugins_url('/img/addthis_large.png', __FILE__) ?>" alt="Large AddThis buttons"/>
    </td>
    <td>
      <input type="radio" name="<?php echo $addthis_field_name; ?>" value="large" <?php if ($addthis == "large") { ?>checked<?php } ?>/>
    </td>
  </tr>
  <tr>
    <td>
      <img src="<?php echo plugins_url('/img/addthis_small.png', __FILE__) ?>" alt="Small AddThis buttons"/>
    </td>
    <td>
      <input type="radio" name="<?php echo $addthis_field_name; ?>" value="small" <?php if ($addthis == "small") { ?>checked<?php } ?>/>
    </td>
  </tr>
  <tr>
    <td>
      <img src="<?php echo plugins_url('/img/addthis_button.png', __FILE__) ?>" alt="Single AddThis button"/>
    </td>
    <td>
      <input type="radio" name="<?php echo $addthis_field_name; ?>" value="button" <?php if ($addthis == "button") { ?>checked<?php } ?>/>
    </td>
  </tr>
</table>
</table>
</table>
</p>
<hr />
Use the [cw_feedzilla_newsfeed] shortcode on any page to display the news.
<p/>
The shortcode also accepts the following attributes, all of which are optional:
<br/>
[cw_feedzilla_newsfeed language="en_us" category="World News" subcategory="Top Stories" order="date" search="wordpress"]
<p/>
<hr/>

<p class="submit">
<input id="submit" type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
<input id="clear_cache" type="button" name="ClearCache" class="button-primary" value="<?php esc_attr_e('Clear Cache') ?>" onclick='jQuery.ajax ({type: "post", url: ajaxurl, data: { action: "cw_feedzilla_clear_cache" }, error: function(aObject, aTextStatus, aErrorThrown) { alert("Unable to clear cache: " + aTextStatus + "/" + aErrorThrown); }, success: function (aHtml) { alert("Cache cleared");}});'/>
</p>

</form>
</div>

<?php

}

function cw_feedzilla_scripts() {
  wp_enqueue_script( 'jquery' );

  wp_register_style('cw_feedzilla_styles', plugins_url('/css/cw-feedzilla.css', __FILE__));
  wp_enqueue_style('cw_feedzilla_styles');
  wp_enqueue_script('cw_feedzilla_ajax_script', plugins_url('/js/cw-feedzilla.js', __FILE__));
  wp_localize_script('cw_feedzilla_ajax_script', 'ajax_object', array( 'ajax_url' => admin_url('admin-ajax.php'), 'we_value' => 1234));
}

function cw_feedzilla_write_to_cache($aName, $aValue) {
  $upload_dir = wp_upload_dir();
  if (isset($upload_dir) && is_array($upload_dir) && isset($upload_dir["path"])) {
    $cache = fopen($upload_dir["path"] . "/cw_feedzilla_cache_$aName", "w");
    fwrite($cache, json_encode($aValue));
    fclose($cache);
  }
}

function cw_feedzilla_read_from_cache($aName) {
  $value = null;

  $upload_dir = wp_upload_dir();
  if (isset($upload_dir) && is_array($upload_dir) && isset($upload_dir["path"])) {
    $file_name = $upload_dir["path"] . "/cw_feedzilla_cache_$aName";
    if (file_exists($file_name)) {
      $cache = fopen($file_name, "r");
      $value = fgets($cache);
      fclose($cache);

      $value = json_decode($value);
    }
  }
  return $value;
}

function cw_feedzilla_clear_cache_callback () {
  $upload_dir = wp_upload_dir();
  if (isset($upload_dir) && is_array($upload_dir) && isset($upload_dir["path"])) {
    $files = glob($upload_dir["path"] . "/cw_feedzilla_cache_*");
    foreach ($files as $file) {
      if (is_file($file)) {
        unlink($file);
      }
    }
  }
}

function cw_feedzilla_cultures_callback () {
  //Refresh the news listing
  $mCultures = cw_feedzilla_read_from_cache("cultures");
  if (isset($mCultures) && trim($mCultures) != '') {
    $html = $mCultures;
  } else {
    $api_url_opt_name = 'cw_feedzilla_api_url';

      // Read in existing option value from database
    $api_url = get_option( $api_url_opt_name, 'http://api.feedzilla.com/v1' );
    $message = wp_remote_get($api_url . '/cultures.json', array('timeout' => 30));
    if (is_wp_error($message)) {
      $html = print_r($message, true);
    } else {
      $cultures = json_decode($message['body']);
      $html = "<option>Select a Language</option>";
      foreach ($cultures as $culture) {
	$html .= "<option value=\"$culture->culture_code\">$culture->display_culture_name</option>";
      }
      cw_feedzilla_write_to_cache("cultures", $html);
    }
  }
  echo $html;
  die();
}

function cw_feedzilla_categories_callback () {
  $culture_code = $_POST['culture_code'];
  $mCategories = cw_feedzilla_read_from_cache("categories_" . $culture_code);
  if (isset($mCategories) && trim($mCategories) != "") {
    $html = $mCategories;
  } else {
    //Refresh the news listing
    $api_url_opt_name = 'cw_feedzilla_api_url';

      // Read in existing option value from database
    $api_url = get_option( $api_url_opt_name, 'http://api.feedzilla.com/v1' );
    $message = wp_remote_get($api_url . "/categories.json?culture_code=$culture_code", array("timeout" => 30));
    if (is_wp_error($message)) {
      $html = print_r($message, true);
    } else {
      $categories = json_decode($message['body']);
      $html = "<option>Select a Category</option>";
      foreach ($categories as $category) {
	if ($category->display_category_name != '') {
	  $html .= "<option value=\"$category->category_id\">$category->display_category_name</option>";
	}
      }
      cw_feedzilla_write_to_cache("categories_" . $culture_code, $html);
    }
  }
  echo $html;
  die();
}

function cw_feedzilla_subcategories_callback () {
  $category_code = $_POST['category_code'];
  $mSubcategories = cw_feedzilla_read_from_cache("subcategories_" . $category_code);
  if (isset($mSubcategories) && trim($mSubcategories) != '') {
    $html = $mSubcategories;
  } else {
    //Refresh the news listing
    $api_url_opt_name = 'cw_feedzilla_api_url';

      // Read in existing option value from database
    $api_url = get_option( $api_url_opt_name, 'http://api.feedzilla.com/v1' );
    $message = wp_remote_get($api_url . "/categories/$category_code/subcategories.json", array("timeout" => 30));
    if (is_wp_error($message)) {
      $html = print_r($message, true);
    } else {
      $subcategories = json_decode($message['body']);
      $html = "<option>Select a Subcategory</option>";
      foreach ($subcategories as $subcategory) {
	if ($subcategory->display_subcategory_name != '') {
	  $html .= "<option value=\"$subcategory->subcategory_id\">$subcategory->display_subcategory_name</option>";
	}
      }
      cw_feedzilla_write_to_cache("subcategories_" . $category_code, $html);
    }
  }
  echo $html;
  die();
}

function cw_feedzilla_refresh_callback () {
  $category_code = $_POST['category_code'];
  if (!isset($category_code) || trim($category_code) == '') {
    $category_code = "19";
  }
  $subcategory_code = $_POST['subcategory_code'];
  $search_term = $_POST['search_term'];
  $order = $_POST['order'];

  //Refresh the news listing
  $api_url_opt_name = 'cw_feedzilla_api_url';
  $headline_count_opt_name = 'cw_feedzilla_headline_count';
  $title_only_opt_name = 'cw_feedzilla_title_only';
  $include_images_opt_name = 'cw_feedzilla_include_images';
  $auto_refresh_opt_name = 'cw_feedzilla_auto_refresh';
  $addthis_id_opt_name = 'cw_feedzilla_addthis_id';
  $addthis_opt_name = 'cw_feedzilla_addthis';

  // Read in existing option value from database
  $api_url = get_option( $api_url_opt_name, 'http://api.feedzilla.com/v1' );
  $headline_count = get_option( $headline_count_opt_name, '20' );
  $title_only = get_option( $title_only_opt_name, false );
  $include_images = get_option( $include_images_opt_name, true );
  $auto_refresh = get_option( $auto_refresh_opt_name, true );
  $addthis_id = get_option( $addthis_id_opt_name, 'ra-52d85cbe4587626d' );
  $addthis = get_option( $addthis_opt_name, 'default' );

  if (!isset($search_term) || $search_term == null || $search_term == '') {
    $message = wp_remote_get($api_url . "/categories/$category_code" . (isset($subcategory) ? "/subcategories/$subcategory_code" : "") . "/articles.json?count=$headline_count&title_only=" . ($title_only ? "1" : "0") . "&order=$order", array("timeout" => 30));
  } else {
    $message = wp_remote_get($api_url . "/categories/$category_code" . (isset($subcategory) ? "/subcategories/$subcategory_code" : "") . "/articles/search.json?q=$search_term&count=$headline_count&title_only=" . ($title_only ? "1" : "0") . "&order=$order", array("timeout" => 30));
  }

  if (is_wp_error($message)) {
    $html .= '<div class="cw_feedzilla_article">';
    $html .= print_r($message, true);
    $html .= '</div>';
  } else {
    $article_list = json_decode($message['body']);
    $html = "";
    if (is_array($article_list->articles)) {
      foreach ($article_list->articles as $article) {
	$html .= '<div class="cw_feedzilla_article">';
	$html .= '  <div class="cw_feedzilla_headline"><a href="';
	$html .= $article->url;
	$html .= '">';
	$html .= $article->title;
	$html .= '</a>';
	$html .= '  </div>';
	$html .= '  <div class="cw_feedzilla_publish_date">';
	$html .= $article->publish_date;
	$html .= '  </div>';
	$html .= '  <div class="cw_feedzilla_summary">';
	$html .= isset($article->summary) ? $article->summary : "";
	$html .= '&nbsp;<a href="';
	$html .= $article->url;
	$html .= '">More&hellip;</a>';
	$html .= '  </div>';
	if (isset($article->enclosures) && $article->enclosures && sizeof($article->enclosures) > 0) {
	  foreach ($article->enclosures as $enclosure) {
	    if (strpos($enclosure->media_type, 'image') !== FALSE) {
	      if ($include_images) {
		$html .= '  <div class="cw_feedzilla_image">';
		$html .= '    <img src="';
		$html .= $enclosure->uri;
		$html .= '"/>';
		$html .= '  </div>';
	      }
	    }
	  }
	}
        if ($addthis == 'default') {
          $html .= '<div class="addthis_buttons">';
	  $html .= '<!-- AddThis Button BEGIN -->';
	  $html .= '<div class="addthis_toolbox addthis_default_style " addthis:url="' . $article->url . '" addthis:title="' . $article->title . '">';
	  $html .= '<a class="addthis_button_facebook_like" fb:like:layout="button_count"></a>';
	  $html .= '<a class="addthis_button_tweet"></a>';
	  $html .= '<a class="addthis_button_pinterest_pinit" pi:pinit:layout="horizontal"></a>';
	  $html .= '<a class="addthis_counter addthis_pill_style"></a>';
	  $html .= '</div>';
	  //$html .= '<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=' . $addthis_id . '"></script>';
	  $html .= '<!-- AddThis Button END -->';
          $html .= '</div>';
        } else if ($addthis == 'large') {
          $html .= '<div class="addthis_buttons">';
	  $html .= '<!-- AddThis Button BEGIN -->';
	  $html .= '<div class="addthis_toolbox addthis_default_style addthis_32x32_style" addthis:url="' . $article->url . '" addthis:title="' . $article->title . '">';
	  $html .= '<a class="addthis_button_preferred_1"></a>';
	  $html .= '<a class="addthis_button_preferred_2"></a>';
	  $html .= '<a class="addthis_button_preferred_3"></a>';
	  $html .= '<a class="addthis_button_preferred_4"></a>';
	  $html .= '<a class="addthis_button_compact"></a>';
	  $html .= '<a class="addthis_counter addthis_bubble_style"></a>';
	  $html .= '</div>';
	  //$html .= '<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=' . $addthis_id . '"></script>';
	  $html .= '<!-- AddThis Button END -->';
          $html .= '</div>';
        } else if ($addthis == 'small') {
          $html .= '<div class="addthis_buttons">';
	  $html .= '<!-- AddThis Button BEGIN -->';
	  $html .= '<div class="addthis_toolbox addthis_default_style " addthis:url="' . $article->url . '" addthis:title="' . $article->title . '">';
	  $html .= '<a class="addthis_button_preferred_1"></a>';
	  $html .= '<a class="addthis_button_preferred_2"></a>';
	  $html .= '<a class="addthis_button_preferred_3"></a>';
	  $html .= '<a class="addthis_button_preferred_4"></a>';
	  $html .= '<a class="addthis_button_compact"></a>';
	  $html .= '<a class="addthis_counter addthis_bubble_style"></a>';
	  $html .= '</div>';
	  //$html .= '<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=' . $addthis_id . '"></script>';
	  $html .= '<!-- AddThis Button END -->';
          $html .= '</div>';
        } else if ($addthis == 'button') {
          $html .= '<div class="addthis_buttons">';
          $html .= '<div style="display: block; clear: both">';
	  $html .= '<!-- AddThis Button BEGIN -->';
	  $html .= '<a class="addthis_button" href="http://www.addthis.com/bookmark.php?v=300&amp;pubid=' . $addthis_id . '" addthis:url="' . $article->url .'" addthis:title="' . $article->title . '"><img src="http://s7.addthis.com/static/btn/v2/lg-share-en.gif" width="125" height="16" alt="Bookmark and Share" style="border:0"/></a>';
	  //$html .= '<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=' . $addthis_id . '"></script>';
	  $html .= '<!-- AddThis Button END -->';
          $html .= '</div>';
          $html .= '</div>';
        }
	$html .= '</div>';
      }
    }
  }

  if ($html == "") {
    $html = '<div class="cw_feedzilla_article"><div class="cw_feedzilla_headline">No Matching Articles Found</div></div>';
  }
  $html .= '<div id="cw_feedzilla_logo"><a href="http://www.feedzilla.com"><img src="' . plugins_url("/img/feedzilla-logo.png", __FILE__) . '"/></a></div>';
  if ($auto_refresh) {
    $html .= '<script type="text/javascript">scheduleRefresh();</script>';
  }
  echo $html;

  die();
}

function cw_feedzilla_refresh_with_names_callback () {
  $culture_code = $_POST['culture_code'];
  $category_name = $_POST['category_name'];
  $subcategory_name = $_POST['subcategory_name'];
  $search_term = $_POST['search_term'];
  $order = $_POST['order'];

  //Refresh the news listing
  $api_url_opt_name = 'cw_feedzilla_api_url';
  $headline_count_opt_name = 'cw_feedzilla_headline_count';
  $title_only_opt_name = 'cw_feedzilla_title_only';
  $include_images_opt_name = 'cw_feedzilla_include_images';
  $auto_refresh_opt_name = 'cw_feedzilla_auto_refresh';

  // Read in existing option value from database
  $api_url = get_option( $api_url_opt_name, 'http://api.feedzilla.com/v1' );
  $headline_count = get_option( $headline_count_opt_name, '20' );
  $title_only = get_option( $title_only_opt_name, false );
  $include_images = get_option( $include_images_opt_name, true );
  $auto_refresh = get_option( $auto_refresh_opt_name, true );

  $message = wp_remote_get($api_url . "/categories.json?culture_code=$culture_code", array('timeout' => 30));
  if (is_wp_error($message)) {
  } else {
    $response = $message['response'];
    if (isset($response) && is_array($response) && $response['code'] == '200') {
      $categories = json_decode($message['body']);
      foreach ($categories as $category) {
	if ($category->category_id == $category_name || $category->display_category_name == $category_name) {
	  $category_code = $category->category_id;
	}
      }
    }
  }

  $message = wp_remote_get($api_url . "/categories/$category_code/subcategories.json", array('timeout' => 30));
  if (is_wp_error($message)) {
  } else {
    $response = $message['response'];
    if (isset($response) && is_array($response) && $response['code'] == '200') {
      $subcategories = json_decode($message['body']);
      foreach ($subcategories as $subcategory) {
	if ($subcategory->subcategory_id == $subcategory_name || $subcategory->display_subcategory_name == $subcategory_name) {
	  $subcategory_code = $subcategory->subcategory_id;
	}
      }
    }
  }

  $request_url = "";
  
  if (!isset($search_term) || $search_term == null || trim($search_term) == '') {
    $request_url = $api_url . "/categories/" . (isset($category_code) ? $category_code : "19") . (isset($subcategory_code) ? "/subcategories/$subcategory_code" : "") . "/articles.json?count=$headline_count&title_only=" . ($title_only ? "1" : "0") . "&order=$order";
  } else {
    $request_url = $api_url . "/categories/" . (isset($category_code) ? $category_code : "19") . (isset($subcategory_code) ? "/subcategories/$subcategory_code" : "") . "/articles/search.json?q=$search_term&count=$headline_count&title_only=" . ($title_only ? "1" : "0") . "&order=$order";
  }
  $message = wp_remote_get($request_url, array('timeout' => 30));

  $html = "";
  if (is_wp_error($message)) {
  } else {
    $response = $message['response'];
    $article_list = json_decode($message['body']);
    if (is_array($response) && $response['code'] == '200') {
      if (is_array($article_list->articles)) {
	foreach ($article_list->articles as $article) {
	  $html .= '<div class="cw_feedzilla_article">';
	  $html .= '  <div class="cw_feedzilla_headline"><a href="';
	  $html .= $article->url;
	  $html .= '">';
	  $html .= $article->title;
	  $html .= '</a>';
	  $html .= '  </div>';
	  $html .= '  <div class="cw_feedzilla_publish_date">';
	  $html .= $article->publish_date;
	  $html .= '  </div>';
	  $html .= '  <div class="cw_feedzilla_summary">';
	  $html .= isset($article->summary) ? $article->summary : "";
	  $html .= '&nbsp;<a href="';
	  $html .= $article->url;
	  $html .= '">More&hellip;</a>';
	  $html .= '  </div>';
	  if (isset($article->enclosures) && $article->enclosures && sizeof($article->enclosures) > 0) {
	    foreach ($article->enclosures as $enclosure) {
	      if (strpos($enclosure->media_type, 'image') !== FALSE) {
		if ($include_images) {
		  $html .= '  <div class="cw_feedzilla_image">';
		  $html .= '    <img src="';
		  $html .= $enclosure->uri;
		  $html .= '"/>';
		  $html .= '  </div>';
		}
	      }
	    }
	  }
	  $html .= '</div>';
	}
      }
    } else if (isset($response) && is_array($response) && isset($response['message'])) {
      $html = '<div class="cw_feedzilla_article"><div class="cw_feedzilla_headline">Request error: ' . $response['message'] . '<p/>URL: ' . $request_url . '</div></div>';
    }
  }

  if ($html == "") {
    $html = '<div class="cw_feedzilla_article"><div class="cw_feedzilla_headline">No Matching Articles Found</div></div>';
  }
  $html .= '<div id="cw_feedzilla_logo"><a href="http://www.feedzilla.com"><img src="' . plugins_url("/img/feedzilla-logo.png", __FILE__) . '"/></a></div>';
  if ($auto_refresh) {
    $html .= '<script type="text/javascript">scheduleRefresh();</script>';
  }
  echo $html;

  die();
}

function cw_feedzilla_newsfeed_handler ($atts, $content, $tag) {
  extract(
    shortcode_atts(
      array('language' => null, 
            'category' => null,
            'subcategory' => null,
            'order' => null,
            'search' => '--NOT SET--'), 
      $atts));
      if ($search == '--NOT SET--') {
        $search = null;
      } else if ($search == null) {
        $search = ' ';
      }
  ?>
  <? $hide_navbar = $language != null && $category != null && $subcategory != null && $order != null && $search != null; ?>
    <div id="cw_feedzilla_navbar" <?php if ($hide_navbar) { ?>class="hidden_navbar"<?php } ?>>
      <?php if ($language == null) { ?>
	<div class="cw_feedzilla_navbar_title">
	  Language:
	</div>
	<div class="cw_feedzilla_navbar_section">
	  <select id="cw_feedzilla_cultures" class="cw_feedzilla_select">
	  </select>
	</div>
      <?php } else { ?>
        <script type="text/javascript">
          localStorage.setItem("cw_feedzilla_culture", "<?php echo $language ?>");
        </script>
      <?php } ?>
      <?php if ($category == null) { ?>
	<div class="cw_feedzilla_navbar_title">
	  Category:
	</div>
	<div class="cw_feedzilla_navbar_section">
	  <select id="cw_feedzilla_categories" class="cw_feedzilla_select">
	  </select>
	</div>
      <?php } else { ?>
        <script type="text/javascript">
          localStorage.setItem("cw_feedzilla_category", "<?php echo $category ?>");
        </script>
      <?php } ?>
      <?php if ($subcategory == null) { ?>
	<div class="cw_feedzilla_navbar_title">
	  Subcategory:
	</div>
	<div class="cw_feedzilla_navbar_section">
	  <select id="cw_feedzilla_subcategories" class="cw_feedzilla_select">
	  </select>
	</div>
      <?php } else { ?>
        <script type="text/javascript">
          localStorage.setItem("cw_feedzilla_subcategory", "<?php echo $subcategory ?>");
        </script>
      <?php } ?>
      <?php if ($search == null) { ?>
	<div class="cw_feedzilla_navbar_section">
	  <div class="cw_feedzilla_navbar_title">
	    Search:
	  </div>
	  <div class="cw_feedzilla_navbar_section">
	    <input id="cw_feedzilla_search" type="text"/>
	  </div>
        </div>
      <?php } else { ?>
        <input type="hidden" id="cw_feedzilla_search" value="<?php echo $search ?>"/>
      <?php } ?>
      <?php if ($order == null) { ?>
	<div class="cw_feedzilla_navbar_section">
	  <div class="cw_feedzilla_navbar_title">
	    Sort by:
	  </div>
	  <input id="cw_feedzilla_order_relevance" name="order" type="radio" value="relevance"/>Relevance
	  <br/>
	  <input id="cw_feedzilla_order_date" name="order" type="radio" value="date"/>Date
        </div>
      <?php } else { ?>
         <script type="text/javascript">
           localStorage.setItem("cw_feedzilla_order", "<?php echo $order; ?>");
         </script>
      <?php } ?>
      <div class="cw_feedzilla_navbar_section">
        <input id="cw_feedzilla_refresh" type="button" value="Refresh"/>
        <a href="http://cadreworks.com"><img id="cw_feedzilla_cw_logo" src="<?php echo plugins_url("/img/cadreworks-logo.png", __FILE__); ?>"/></a>
      </div>
    </div>
  <div id="cw_feedzilla_headline_container" <?php if ($hide_navbar) { ?>class="full_size"<?php } ?>>
    <div id="cw_feedzilla_loading">
      Loading&hellip;
    </div>
    <div id="cw_feedzilla_messages">
    </div>
    <div id="cw_feedzilla_headline_list">
    </div>
  </div>
<?php
}
